--This file is meant as an adder to the spellchk.ex written by Miura, RDS.
--You can get WORDS.TXT (50000-word dictionary) from her file.
--It provides for automatic updating of the dictionary provided with spellchk.
--It automatically ignores words ending in 's (removes them from the wrong
--spelling -list). It writes the complete badwords file (including  's words)
--and writes another wrngwrds file containing the words not added to the
--dictionary. The user is asked to decide whether a badword is put in the
--wrong words file for later correction or added to the dictionary as a good
--word.

without type_check
include get.e
include wildcard.e
include sort.e

global procedure fixIt()
  
  integer wordsHandle, badWordsHandle, wrongWordsHandle
  sequence badWords, wrongWords, goodWords
  object word
  wrongWords = {}
  badWords = {}
  badWordsHandle = open("badwords.txt", "r") 
  
  for i = 1 to 1000 do
    word = gets(badWordsHandle)
    if atom(word) then exit
    elsif length(word) > 3 then --Remove       's    words
      if  word[length(word)-2] != 39 then
	badWords= append(badWords,upper(word))
      end if
    else
      badWords= append(badWords,upper(word))
      
    end if
  end for
  close(badWordsHandle) 
  
  wordsHandle = open("words.txt", "a") 
  puts(1,"\nIt contains the questionable words. Now update the dictionary. ")
  puts(1,"\nPress enter to add to dictionary, d to not add\n\n")
  for i = 1 to length(badWords) by 1 do
    puts(1,badWords[i])
    word =  wait_key()
    if word = 13 then
      puts(wordsHandle, badWords[i])
    else wrongWords = append(wrongWords, badWords[i])
    end if
  end for
  close(wordsHandle) 
  
  puts(1, "You selected the followwing as mis-spelled. They are saved in \n")
  puts(1,"the file wrngwrds.txt. The others have been added to the dictionary.\n")
  
  for i = 1 to length(wrongWords) by 1 do
    puts(1, wrongWords[i])
  end for
  puts(1, "\nWait a bit for the bell or the prompt\n")
  wrongWordsHandle = open("wrngwrds.txt", "w") 
  for i = 1 to length(wrongWords) by 1 do
    puts(wrongWordsHandle, wrongWords[i])
  end for
  close(wrongWordsHandle)
  
  
  wordsHandle = open("words.txt", "r") 
  
  badWords = {}
  for i = 1 to 100000 do
    word = gets(wordsHandle)
    if atom(word) then exit
    else
      badWords = append(badWords,upper(word))
    end if
  end for
  goodWords = {}
  
  goodWords = sort(badWords)
  close(wordsHandle)
  wordsHandle = open("words.txt", "w") 
  for i = 1 to length(goodWords) by 1 do
    puts(wordsHandle, goodWords[i])
  end for
  close(wordsHandle)
  
end procedure   --fixIt

